<?php

namespace Litecms\Notice;

use User;

class Notice
{
    /**
     * $notice object.
     */
    protected $notice;

    /**
     * Constructor.
     */
    public function __construct(\Litecms\Notice\Interfaces\NoticeRepositoryInterface $notice)
    {
        $this->notice = $notice;
    }

    /**
     * Returns count of notice.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.notice.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->notice->pushCriteria(new \Litepie\Litecms\Repositories\Criteria\NoticeUserCriteria());
        }

        $notice = $this->notice->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('notice::' . $view, compact('notice'))->render();
    }
}
